package com.biganto.visual.roompark.conductor.dialogs

import android.content.Intent
import android.net.Uri
import android.os.Bundle
import com.biganto.visual.androidplayer.conductor.dialogs.AlertDialogController
import timber.log.Timber


/**
 * Created by Vladislav Bogdashkin on 09.04.2019.
 */
class UpdateAppAlertDialogController: AlertDialogController {

    constructor(args: Bundle) : super(args)

    constructor(message: String, buttonText: String) : super(message, buttonText)

    override var dismissActionDelegate = {
        val appPackageName = activity?.packageName
        var uri = Uri.parse("https://cdn.fishki.net/upload/post/201502/17/1432283/659d2f29de589d5d41252f18e9beb292.jpg")
//        uri = Uri.parse("market://details?id=$appPackageName");
        try {
            startActivity(Intent(Intent.ACTION_VIEW, uri))
        } catch (e: Exception) {
            when (e) {
                is android.content.ActivityNotFoundException -> {
                    uri = Uri.parse("https://play.google.com/store/apps/details?id=$appPackageName")
                    startActivity(Intent(Intent.ACTION_VIEW, uri))
                }
                else -> {
                    Timber.e("Fatal exception occured, while try to update app version!: $e")
                    activity?.finish()
                }
            }
        }
        Unit
    }
}