package com.biganto.visual.roompark.di.dagger

import android.app.Application
import com.squareup.picasso.Picasso
import dagger.Module
import dagger.Provides
import java.util.concurrent.Executors
import javax.inject.Singleton

/**
 * Created by Vladislav Bogdashkin on 16.12.2019.
 */

private const val THREAD_POOL_COUNT = 4

@Module
class PicassoModule{

    @Provides
    @Singleton
    fun providePicassoAsyncSingleton(context: Application): Picasso {
            val executor = Executors.newFixedThreadPool(THREAD_POOL_COUNT)
            return Picasso.Builder(context)
                .executor(executor)
                .build()
        }
}