package com.biganto.visual.roompark.presentation.screen.albums.util

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.domain.model.AlbumPreviewModel
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.squareup.picasso.Picasso
import java.text.SimpleDateFormat
import java.util.*


/**
 * Created by Vladislav Bogdashkin on 15.10.2019.
 */
class AlbumsHeaderAdapter : CommonRecyclerAdapter<AlbumsHeaderViewHolder, AlbumPreviewModel>() {

    override val vhKlazz = AlbumsHeaderViewHolder::class

    override fun getVhLayout(): Int = R.layout.album_header_preview_viewholder

    fun getItemPosition(model: AlbumPreviewModel) = getItemPosition(model.albumId)

    fun getItemPosition(modelId: Int) = list.indexOfFirst {
        it.albumId == modelId
    }
}


class AlbumsHeaderViewHolder(itemView: View) : CommonViewHolder<AlbumPreviewModel>(itemView) {

    private val dateFormatter = SimpleDateFormat("dd MMMM yyyy", Locale("ru"))

    @BindView(R.id.preview) lateinit var preview:ImageView
    @BindView(R.id.card_title) lateinit var articleTitle:TextView
    @BindView(R.id.card_updated) lateinit var articleDate:TextView


    override fun onViewBound(model: AlbumPreviewModel) {
//        articleDate.text = dateFormatter.format(model.published)
        articleTitle.text = model.title
        Picasso.get()
            .load(model.previewUrl)
            .centerCrop()
            .fit()
            .into(preview)

//        
    }
}
