package com.biganto.visual.roompark.presentation.screen.feeds.utils

import android.view.View
import android.widget.ImageView
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.domain.model.WebCamModel
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.google.android.material.textview.MaterialTextView


/**
 * Created by Vladislav Bogdashkin on 15.10.2019.
 */
class CamsListAdapter : CommonRecyclerAdapter<CamListViewHolder,WebCamModel>() {
    override val vhKlazz = CamListViewHolder::class

    override fun getVhLayout(): Int = R.layout.cam_button_viewholder
}

class CamListViewHolder(itemView: View) : CommonViewHolder<WebCamModel>(itemView) {

    @BindView(R.id.camTitle) lateinit var camTitle:MaterialTextView
    @BindView(R.id.camStatus) lateinit var camStatus: MaterialTextView
    @BindView(R.id.camStatusIcon) lateinit var camStatusIcon:ImageView

    override fun onViewBound(model: WebCamModel) {
        camTitle.text = model.title
        camStatus.text = if (model.streams.isNullOrEmpty()) "ОФФЛАЙН" else "ОНЛАЙН"
        camStatusIcon.visibility = if (model.streams.isNullOrEmpty()) View.GONE else View.VISIBLE
    }
}
