

import android.content.res.Resources
import android.graphics.Bitmap
import android.graphics.Canvas
import android.graphics.drawable.BitmapDrawable
import android.graphics.drawable.Drawable
import android.text.Html
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.RoomParkApplication
import com.google.android.material.textview.MaterialTextView
import com.squareup.picasso.Picasso
import com.squareup.picasso.Target
import timber.log.Timber


class PicassoImageGetter(private val target: MaterialTextView) : Html.ImageGetter {

    override fun getDrawable(source: String): Drawable {
        val drawable = BitmapDrawablePlaceHolder()
        Picasso.get()
            .load("https://room-park.ru$source")
            .placeholder(R.drawable.ic_deals)
            .into(drawable)
        return drawable
    }

    private inner class BitmapDrawablePlaceHolder : BitmapDrawable(), Target{

        protected var _drawable: Drawable? = null

        private val resources: Resources = RoomParkApplication.component.provideAppContext().resources

        override fun draw(canvas: Canvas) {
            if (_drawable != null) {
                _drawable!!.draw(canvas)
            }
        }

        fun setDrawable(drawable: Drawable) {
            this._drawable = drawable
            var width = drawable.intrinsicWidth
            var height = drawable.intrinsicHeight
            Timber.d("WE GONNA WORK WITH DATA: ${target.width} / ${target.height}")
            Timber.d("WE GONNA WORK WITH M DATA: ${target.measuredWidth} / ${target.measuredHeight}")
            target.width.let{
                val aspect = width.toFloat()/it.toFloat()
                Timber.d("aspect is $aspect")
                val imgWider = width>it
                Timber.d("imgWider is $imgWider")
                height = if (imgWider)  (height.toFloat()/aspect).toInt()
                    else (height.toFloat()*aspect).toInt()
                width = if (imgWider)  it else it//imgWider

                drawable.setBounds(0, 0, width, height)
                setBounds(0, 0, width, height)


            }
            target.text=target.text

        }

        override fun onBitmapLoaded(bitmap: Bitmap, from: Picasso.LoadedFrom) {
            setDrawable(BitmapDrawable(resources, bitmap))
        }

        override fun onBitmapFailed(e: Exception?, errorDrawable: Drawable?) {}

        override fun onPrepareLoad(placeHolderDrawable: Drawable) {

        }

    }
}